123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146 |
- #! /bin/sh
- . test-init.sh
- cat >> configure.ac << 'END'
- AC_OUTPUT
- END
- cat > Makefile.am << 'END'
- TEST_LOG_DRIVER = ./passthrough-driver
- TEST_LOG_COMPILER = $(SHELL) -e
- END
- cat > passthrough-driver <<'END'
- #!/bin/sh
- set -e; set -u;
- while test $# -gt 0; do
- case $1 in
- --log-file) log_file=$2; shift;;
- --trs-file) trs_file=$2; shift;;
- --test-name) test_name=$2; shift;;
- --expect-failure|--color-tests|--enable-hard-errors) shift;;
- --) shift; break;;
- *) echo "$0: invalid option/argument: '$1'" >&2; exit 2;;
- esac
- shift
- done
- echo "$test_name: RUN"
- "$@" >$log_file 2>&1 5>$trs_file
- END
- chmod a+x passthrough-driver
- cat > no-1.test <<END
- echo :test-result: SKIP >&5
- echo :copy-in-global-log: no >&5
- echo :test-result: FAIL >&5
- echo :test-result: XPASS >&5
- echo not seen 1
- END
- cat > no-2.test <<END
- echo ":test-result: FAIL" >&5
- echo "not seen 2"
- echo ":recheck: yes" >&5
- echo ":copy-in-global-log:$tab $tab no $tab" >&5
- END
- for RES in XPASS FAIL XFAIL SKIP ERROR UNKNOWN; do
- unindent > $RES.test <<END
- echo :test-result: $RES >&5
- echo :copy-in-global-log: no >&5
- echo not seen $RES
- END
- done
- cat > no-3.test <<END
- echo :copy-in-global-log:no >&5
- echo ":test-result: FAIL" >&5
- echo "not seen 3"
- END
- cat > no-4.test <<END
- echo ":test-result: FAIL" >&5
- echo " $tab $tab$tab :copy-in-global-log: no" >&5
- echo "not seen 4"
- END
- cat > yes-1.test <<END
- echo :test-result: PASS >&5
- echo :copy-in-global-log: yes >&5
- echo seen yes 1
- END
- cat > yes-2.test <<END
- echo :test-result: PASS >&5
- echo seen yes 2
- END
- cat > corn-1.test <<END
- echo seen corn 1
- echo ':copy-in-global-log:' >&5
- END
- cat > corn-2.test <<END
- echo seen corn 2
- echo '$tab $tab$tab' >&5
- END
- cat > corn-3.test <<'END'
- echo seen corn 31
- echo ':copy-in-global-log:#@%!' >&5
- echo seen corn 32
- END
- echo TESTS = *.test >> Makefile.am
- $ACLOCAL
- $AUTOCONF
- $AUTOMAKE
- ./configure
- $MAKE check || :
- cat test-suite.log
- grep '^seen yes 1$' test-suite.log
- grep '^seen yes 2$' test-suite.log
- grep '^seen corn 1$' test-suite.log
- grep '^seen corn 2$' test-suite.log
- grep '^seen corn 31$' test-suite.log
- grep '^seen corn 32$' test-suite.log
- $FGREP 'not seen' test-suite.log && exit 1
- :
|